const { app, BrowserWindow, screen, webContents, ipcMain} = require('electron');
const EventEmitter = require('events');
const path = require('path');
const wavPlayer = require('node-wav-player');
//const { clear } = require('console');
//const fs = require('fs');
//const { start } = require('repl');

if (require('electron-squirrel-startup')) {
  app.quit();
}


let mainWindow;



function createWindow () {
  // Create the browser window.
  mainWindow = new BrowserWindow({
    width: 160,
    height: 110, 
    show: false,
    transparent: true,
    frame: false,
    resizable: false,
    hasShadow: false,
    alwaysOnTop: true,
    webPreferences:{
      nodeIntegration: true,
      contextIsolation: false
    }
  })

  // and load the index.html of the app.
  //mainWindow.loadURL("file:///Users/beatricewetton/Desktop/my-app/src/index.html")
  mainWindow.loadFile(path.join(__dirname, 'index.html'));



  mainWindow.once('ready-to-show', () => {
    mainWindow.show();
    animateWindow();
    wavPlayer
      .play({
        path: audioPath,
      })
      .then(() => {
        // Playback finished
      })
      .catch((error) => {
        // Error occurred while playing audio
        console.error(error);
      });
  });



  // Open the DevTools.
  //mainWindow.webContents.openDevTools()

  // Emitted when the window is closed.
  mainWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    mainWindow = null

  })

  mainWindow.setPosition(20,20)
}



//var createSettingsWindow;
var settingsWindow;

// Inside the createWindow function, create the settings window
function createSettingsWindow() {
  // ...

  // Create the settings window
  settingsWindow = new BrowserWindow({
    width: 400,
    height: 500,
    // Set the position of the settings window
    frame: false,
    x: 100,
    y: 100,
    show: false,
    resizable: false,
    webPreferences:{
      nodeIntegration: true,
      contextIsolation: false
    }
    // Other settings for the window
  });


  settingsWindow.loadFile(path.join(__dirname, 'settings.html'));


}

var sleepWindow;

function createSleepWindow () {
  // Create the browser window.
  sleepWindow = new BrowserWindow({
    width: 160,
    height: 110, 
    show: false,
    transparent: true,
    frame: false,
    resizable: false,
    hasShadow: false,
    alwaysOnTop: true,
    webPreferences:{
      nodeIntegration: true,
      contextIsolation: false
    }
  })

  // and load the index.html of the app.
  //mainWindow.loadURL("file:///Users/beatricewetton/Desktop/my-app/src/index.html")
  sleepWindow.loadFile(path.join(__dirname, 'sleep.html'));



  // Emitted when the window is closed.
  sleepWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    sleepWindow= null

  })

  

  sleepWindow.setPosition(20,20)
}

let playWindow;



function createPlayWindow () {
  // Create the browser window.
  playWindow = new BrowserWindow({
    width: 160,
    height: 110, 
    show: false,
    transparent: true,
    frame: false,
    resizable: false,
    hasShadow: false,
    alwaysOnTop: true,
    webPreferences:{
      nodeIntegration: true,
      contextIsolation: false
    }
  })

  // and load the index.html of the app.
  //mainWindow.loadURL("file:///Users/beatricewetton/Desktop/my-app/src/index.html")
  playWindow.loadFile(path.join(__dirname, 'play.html'));



  playWindow.once('ready-to-show', () => {
    //playWindow.show();
    animateChase();
  });



  // Open the DevTools.
  //mainWindow.webContents.openDevTools()

  // Emitted when the window is closed.
  playWindow.on('closed', function () {
    // Dereference the window object, usually you would store windows
    // in an array if your app supports multi windows, this is the time
    // when you should delete the corresponding element.
    playWindow = null

  })

  playWindow.setPosition(20,20)
}



app.on('ready', () => {
  createWindow();
  createSettingsWindow();
  createSleepWindow();
  createPlayWindow()

});


// Quit when all windows are closed, except on macOS. There, it's common
// for applications and their menu bar to stay active until the user quits
// explicitly with Cmd + Q.
app.on('window-all-closed', () => {
  if (process.platform !== 'darwin') {
    app.quit();
  }
});

const audioPath = path.join(__dirname, 'sounds/meow.wav');
const audioPathTwo = path.join(__dirname, 'sounds/catpurr.wav');


//ipc 

let isAudioEnabled = true; // Variable to track the audio state


ipcMain.on("msg", (event, data) => {
  if (data.playModeChecked) {
    mainWindow.hide();
    sleepWindow.hide()
    playWindow.show()
    isAudioEnabled = false;
    settingsWindow.hide()
  } else if(data.normalModeChecked){
    sleepWindow.hide()
    playWindow.hide()
    mainWindow.show()
    isAudioEnabled = true;
    settingsWindow.hide()
    if(data.volumeModeChecked){
      isAudioEnabled = false;
    }
  }else if(data.sleepModeChecked){
    mainWindow.hide()
    playWindow.hide()
    sleepWindow.show()
    isAudioEnabled = false;
    settingsWindow.hide()
  }
});

ipcMain.on("settingsmsg", (event, data) => {
  if (data === true) {
    settingsWindow.show()

    }
});



ipcMain.on("purrmsg", (event, data) => {
  if (data === true) {
    mainWindow.webContents.executeJavaScript(`document.getElementById('cat').src = "images/purring.gif"`)

    }
});




var counter = 0;



function animateWindow() {
  //const audioPath = path.join(__dirname, 'sounds/meow.wav');


  const duration = 5000; // Animation duration in milliseconds
  const startX = mainWindow.getPosition()[0]; // Get the current X position
  const startY = mainWindow.getPosition()[1]; // Get the current Y position
  //const targetX = 400; // Target X position
  //const targetY = 20; // Target Y position
  const { width: screenWidth, height: screenHeight } = screen.getPrimaryDisplay().workAreaSize; // Get the screen width and height
  const targetX = Math.floor(Math.random() * (screenWidth - 200)); // Generate a random X position within the screen bounds
  const targetY = Math.floor(Math.random() * (screenHeight - 200)); 
  const fps = 60; // Frames per second

  const frames = duration / 1000 * fps; // Calculate total frames based on duration and frames per second
  const dx = (targetX - startX) / frames; // Calculate the change in X position per frame
  const dy = (targetY - startY) / frames; // Calculate the change in Y position per frame

  let currentFrame = 0;


  const catflip = `document.getElementById('cat').style.transform = "scaleX(-1)"`
  const catflipback = `document.getElementById('cat').style.transform = "scaleX(1)"`

  const animationInterval = setInterval(() => {

    if (currentFrame < frames) {
      
      const newX = startX + dx * currentFrame; // Calculate the new X position
      const newY = startY + dy * currentFrame; // Calculate the new Y position

    
      if (mainWindow && !mainWindow.isDestroyed()) {


      if(dx < 0){
        mainWindow.webContents.executeJavaScript(catflip)
  

      }else{
        mainWindow.webContents.executeJavaScript(catflipback)

     
      }
    



      

      mainWindow.setPosition(Math.round(newX), Math.round(newY)); // Set the new window position

      currentFrame++;

    
      mainWindow.webContents.executeJavaScript(`document.getElementById('cat').getAttribute('src')`).then((currentSrc) => {

        if(currentSrc == "images/purring.gif"){
          clearInterval(animationInterval)
          //clearInt()
          
          if(isAudioEnabled){
            wavPlayer
            .play({
              path: audioPathTwo,
            })
            .then(() => {
              // Playback finished
            })
            .catch((error) => {
              // Error occurred while playing audio
              console.error(error);
            });
          }

          setTimeout(() => {
            mainWindow.webContents.executeJavaScript(`document.getElementById('cat').src = "images/cat.gif"`)
            animateWindow();
          }, 3000);
          
        }
      });
    }
    
    } else {
      clearInterval(animationInterval);
      counter++
      mainWindow.webContents.executeJavaScript(`document.getElementById('cat').src = "images/catidol.png"`)
      if(counter % 5 === 0){

      
      if(isAudioEnabled){

      
      wavPlayer
      .play({
        path: audioPath,
      })
      .then(() => {
        // Playback finished
      })
      .catch((error) => {
        // Error occurred while playing audio
        console.error(error);
      });
    }
  }




      
     
      setTimeout(() => {
        mainWindow.webContents.executeJavaScript(`document.getElementById('cat').src = "images/cat.gif"`)
        animateWindow();;
      }, 3000);
      //animateWindow();
    }

  }, 1250 / fps);




}


function animateChase() {

  //console.log(screen.getCursorScreenPoint())
  
  const { x, y } = screen.getCursorScreenPoint();
  //mainWindow.setPosition(x, y);

    
  const duration = 5000; // Animation duration in milliseconds
  const startX = playWindow.getPosition()[0]; // Get the current X position
  const startY = playWindow.getPosition()[1]; // Get the current Y position
  //const targetX = 400; // Target X position
  //const targetY = 20; // Target Y position
  //const { width: screenWidth, height: screenHeight } = screen.getPrimaryDisplay().workAreaSize; // Get the screen width and height

   // Generate a random X position within the screen bounds
  const targetX = x //- 60;
  const targetY = y //- 67; 
  const fps = 100; // Frames per second


  const frames = duration / 1000 * fps; // Calculate total frames based on duration and frames per second
  const dx = (targetX - startX) / frames; // Calculate the change in X position per frame
  const dy = (targetY - startY) / frames; // Calculate the change in Y position per frame

  let currentFrame = 0;



  
  
    const animationIntervalPlay = setInterval(() => {
  
      if (currentFrame < frames) {
        
        const newXplay = startX + dx * currentFrame; // Calculate the new X position
        const newYplay  = startY + dy * currentFrame; // Calculate the new Y position

        if (playWindow && !playWindow.isDestroyed()) {
  
        if(dx < 0){
          playWindow.webContents.executeJavaScript(`document.getElementById('catplay').style.transform = "scaleX(-1)"`)
        }else if (dx > 0){
          playWindow.webContents.executeJavaScript(`document.getElementById('catplay').style.transform = "scaleX(1)"`)
        }
  
        playWindow.setPosition(Math.round(newXplay), Math.round(newYplay)); // Set the new window position
  
        currentFrame++;
      }
  
  
      } else {
        clearInterval(animationIntervalPlay);
        animateChase()
      }
  
    }, 100 / fps);

  
  
  }
  
  



// Declare the settingsWindow variable at the top of your code
